#GUNSLINGER STRATOS RELOADED
from inc_noesis import *
import collections

def registerNoesisTypes():
	handle = noesis.register("GUNSLINGER STRATOS RELOADED MDL", ".mdl")
	noesis.setHandlerTypeCheck(handle, gsmdlCheckType)
	noesis.setHandlerLoadModel(handle, gsmdlLoadModel)

	handle = noesis.register("GUNSLINGER STRATOS RELOADED TEX", ".tex")
	noesis.setHandlerTypeCheck(handle, gstexCheckType)
	noesis.setHandlerLoadRGBA(handle, gstexLoadRGBA)
	#noesis.logPopup()

	return 1


def gsmdlCheckType(data):
	td = NoeBitStream(data)
	return 1

def gstexCheckType(data):
	td = NoeBitStream(data)
	return 1

class gsmdlFile: 
         
	def __init__(self, bs):
		self.bs = bs
		self.texList  = []
		self.matList  = []
		self.matInfoList  = []
		self.boneList = []
		self.boneMap  = []
		self.offsetList = []
		self.fvfList = []
		self.meshInfoList = []

	def loadAll(self, bs):
		self.loadMdlHeader(bs)

	def loadMeshNames(self, bs):
		pass
		
	def loadBones(self, bs):
		boneStart = bs.tell()
		boneNames = []
		boneParents = []
		boneMatrix1 = []
		boneMatrix2 = []
		boneMatrix3 = []
		bonePosList = []
		boneInfo = []
		for a in range(0, self.mdlInfo.boneCount):
			boneNames.append(bs.readString())
		#print(boneNames)
		bs.seek(boneStart + self.mdlInfo.boneNameSize, NOESEEK_ABS)
		self.boneMapStart = bs.tell()
		bs.seek(bs.tell() + self.mdlInfo.boneMapSize, NOESEEK_ABS)
		#print(bs.tell())
		for a in range(0, self.mdlInfo.boneCount):
			boneMtx = NoeQuat.fromBytes(bs.readBytes(16)).toMat43()
			bonePos = NoeVec3.fromBytes(bs.readBytes(12))
			boneScl = NoeQuat.fromBytes(bs.readBytes(16))
			boneMtx[3] = bonePos
			boneMatrix1.append(boneMtx)
			bonePosList.append(bonePos)
			boneInfo.append(bs.read("6hIf"))
		#print(bs.tell())
		for a in range(0, self.mdlInfo.boneCount):
			boneMatrix = NoeMat44.fromBytes(bs.readBytes(64)).toMat43()
			boneMatrix[3] = bonePosList[a]
			boneMatrix2.append(boneMatrix)
			newBone = NoeBone(a, boneNames[a], boneMatrix, None, boneInfo[a][0])
			self.boneList.append(newBone)
		for a in range(0, self.mdlInfo.boneCount):
			boneMatrix = NoeMat44.fromBytes(bs.readBytes(64)).toMat43()
			boneMatrix3.append(boneMatrix)
		if len(self.boneList) > 0:
			self.boneList = rapi.multiplyBones(self.boneList)
		#print(bs.tell())
		self.loadMeshInfo(bs)
			
			

	def loadMeshInfo(self, bs):
		for a in range(0, self.mdlInfo.count6):
			matID, matUnk00, matUnk01, vertCount, vertStart, faceCount, faceStart = bs.read("I2h4I")
			self.matInfoList.append((matID, matUnk00, matUnk01, vertCount, faceStart, faceCount, vertStart))
			#print(self.matInfoList[a])
			bs.seek(0x58, NOESEEK_REL)
		#print(bs.tell())
		for a in range(0, self.mdlInfo.count7):
			self.meshInfoList.append(self.mshInfo(*bs.read("13I")))
			#print(self.meshInfoList[a])
		#print(bs.tell())
		self.vertBase = bs.tell()
		bs.seek(self.mdlInfo.vertSize, NOESEEK_REL)
		#print(bs.tell())
		self.faceBase = bs.tell()
		bs.seek(self.mdlInfo.faceSize, NOESEEK_REL)
		#print(bs.tell())
		fvfStart = bs.tell()
		for a in range(0, self.mdlInfo.count7):
			fvfTmp = []
			fvfEnd = 0
			while fvfEnd != -1:
				fvfEnd, fvfPos, compCount, dataType, compType = bs.read("2h2Bh")
				fvfTmp.append((fvfEnd, fvfPos, compCount, dataType, compType))
			self.fvfList.append(fvfTmp)
			#print(self.fvfList[a])
			
		#bs.seek(self.mdlInfo.fvfSize, NOESEEK_REL)
		#print(bs.tell())
		self.loadMeshs(bs)


	def loadUnk1(self, bs):
		pass

	def loadBonePallet(self, bs):
		pass

	def loadTex(self): 
		pass

	def loadMatInfo(self, bs):
		pass

	def loadMeshs(self, bs):
		for a in range(0, self.mdlInfo.count7):
			vtxBase = self.vertBase + self.meshInfoList[a].vtxBufferStart
			idxBase = self.faceBase + self.meshInfoList[a].idxBufferStart
			vtxStride = self.meshInfoList[a].vtxStride
			matBase = self.meshInfoList[a].meshId
			fvfInfo = self.fvfList[a]
			#print(self.meshInfoList[a])
			rapi.rpgSetName(str(self.matInfoList[matBase][0]))
			bs.seek(self.boneMapStart + (self.meshInfoList[a].bonePalletStart * 2), NOESEEK_ABS)
			bonePallet = bs.read(self.meshInfoList[a].bonePalletCount * "H")
			#print(bonePallet)
			if len(bonePallet) > 0:
				rapi.rpgSetBoneMap(bonePallet)
			else:
				rapi.rpgSetBoneMap(None)

			for b in range(0, self.meshInfoList[a].meshCount):
				idxTmp = []
				matInfo = self.matInfoList[matBase + b]
				#print(matInfo)
				bs.seek(vtxBase + (vtxStride * matInfo[4]), NOESEEK_ABS)
				vtxBuff = bs.readBytes(vtxStride * matInfo[3])
				bs.seek(idxBase + (2 * matInfo[6]), NOESEEK_ABS)
				#print(bs.tell(), (2 * matInfo[5]), matInfo[6])
				for c in range(0, matInfo[5]):
					idxTmp.append(bs.readUShort() - matInfo[4])
				idxBuff = struct.pack("<" + 'H'*len(idxTmp), *idxTmp)
				for c in range(0, len(fvfInfo) - 1):
					#print(fvfInfo[c])
					if fvfInfo[c][4] == 0:
						rapi.rpgBindPositionBufferOfs(vtxBuff, noesis.RPGEODATA_FLOAT, vtxStride, fvfInfo[c][1])
					if fvfInfo[c][4] == 2:
						rapi.rpgBindNormalBufferOfs(vtxBuff, noesis.RPGEODATA_FLOAT, vtxStride, fvfInfo[c][1])
					if fvfInfo[c][4] == 8:
						rapi.rpgBindUV1BufferOfs(vtxBuff, noesis.RPGEODATA_FLOAT, vtxStride, fvfInfo[c][1])
					if fvfInfo[c][4] == 7:
						rapi.rpgBindBoneIndexBufferOfs(vtxBuff, noesis.RPGEODATA_BYTE, vtxStride, fvfInfo[c][1], fvfInfo[c][2])
					if fvfInfo[c][4] == 1:
						rapi.rpgBindBoneWeightBufferOfs(vtxBuff, noesis.RPGEODATA_BYTE, vtxStride, fvfInfo[c][1], fvfInfo[c][2])
				
				rapi.rpgCommitTriangles(idxBuff, noesis.RPGEODATA_USHORT, matInfo[5], noesis.RPGEO_TRIANGLE, 1)

	def loadMdlHeader(self, bs):
		self.mdlInfo = self.mdlHeader(*bs.read("11I"))
		#print(self.mdlInfo)
		self.loadBones(bs)


	# mdl Header
	mdlHeader = collections.namedtuple('mdlHeader', ' '.join((
		'boneNameSize',
		'boneMapSize',
		'boneCount',
		'count3',
		'count4',
		'count5',
		'count6',
		'count7',
		'vertSize',
		'faceSize',
		'fvfSize'
	)))

	# mesh Info
	mshInfo = collections.namedtuple('mshInfo', ' '.join((
		'meshId',
		'meshCount',
		'vtxBufferStart',
		'vtxBufferSize',
		'vtxStride',
		'idxBufferStart',
		'idxBufferSize',
		'unk01',
		'unkOff',
		'bonePalletStart',
		'bonePalletCount',
		'unkID',
		'unk02'
	)))

def gsmdlLoadModel(data, mdlList):
	ctx = rapi.rpgCreateContext()
	gsmdl = gsmdlFile(NoeBitStream(data))
	gsmdl.loadAll(gsmdl.bs)
	try:
		mdl = rapi.rpgConstructModel()
	except:
		mdl = NoeModel()
	mdl.setModelMaterials(NoeModelMaterials(gsmdl.texList, gsmdl.matList))
	mdlList.append(mdl); mdl.setBones(gsmdl.boneList)	
	return 1


def gstexLoadRGBA(data, texList):
	ctx = rapi.rpgCreateContext()
	bs = NoeBitStream(data)
	imgWidth, imgHeight, type1, type2, type3, type4, unk00 = bs.read("2H4BI")
	#print((imgWidth, imgHeight, type1, type2, type3, type4, unk00))
	if type3 == 0:
		if type4 == 17:
			texFmt = noesis.NOESISTEX_RGBA32
			#print("RGBA")
			dataSize = (imgWidth * imgHeight * 4)
			texData = bs.readBytes(dataSize)
			texData = rapi.imageDecodeRaw(texData, imgWidth, imgHeight, "b8g8r8p8")
			tex1 = NoeTexture("1", imgWidth, imgHeight, texData, texFmt)
			texList.append(tex1)
		else:
			texFmt = noesis.NOESISTEX_DXT1
			#print("DXT1")
			dataSize = (imgWidth * imgHeight * 4) // 8
			texData = bs.readBytes(dataSize)
			tex1 = NoeTexture("1", imgWidth, imgHeight, texData, texFmt)
			texList.append(tex1)
	elif type3 == 16:
		if type4 == 17:
			texFmt = noesis.NOESISTEX_RGBA32
			#print("RGBA")
			dataSize = (imgWidth * imgHeight * 4)
			texData = bs.readBytes(dataSize)
			texData = rapi.imageDecodeRaw(texData, imgWidth, imgHeight, "b8g8r8p8")
			tex1 = NoeTexture("1", imgWidth, imgHeight, texData, texFmt)
			texList.append(tex1)
		else:
			texFmt = noesis.NOESISTEX_DXT3
			#print("DXT5")
			dataSize = (imgWidth * imgHeight * 8) // 8
			texData = bs.readBytes(dataSize)
			tex1 = NoeTexture("1", imgWidth, imgHeight, texData, texFmt)
			texList.append(tex1)
	elif type3 == 32:
		texFmt = noesis.NOESISTEX_DXT5
		#print("DXT5")
		dataSize = (imgWidth * imgHeight * 8) // 8
		texData = bs.readBytes(dataSize)
		tex1 = NoeTexture("1", imgWidth, imgHeight, texData, texFmt)
		texList.append(tex1)

	return 1